> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Add Members

> Add Members — CometChat documentation.

## Overview

`CometChatAddMembers` is a [Component](/docs/ui-kit/angular/v4/components-overview#components) that allows administrators or group owners to add new members to a specific group. It enables administrators or group owners to extend the membership of a group by adding new users to participate in the group's discussions and activities. By utilising this feature, administrators can manage group membership, and control access to group content. The administrator can select the desired users to be added to the group. This can be done by searching for specific users, selecting from a list of available users. The selected users will receive notifications to join the group.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/pIKiBC-6hdnqY01x/images/5397c96f-add_members_overview_web_screens-1349c4ce85da4a0262b74367cfc5c272.png?fit=max&auto=format&n=pIKiBC-6hdnqY01x&q=85&s=8b8b808b60cf38b133ed839dcf2d7fca" width="3600" height="2400" data-path="images/5397c96f-add_members_overview_web_screens-1349c4ce85da4a0262b74367cfc5c272.png" />
</Frame>

The Add Members component is composed of the following Components:

| Components                                 | Description                                                     |
| ------------------------------------------ | --------------------------------------------------------------- |
| cometchat-button                           | This component represents a button with optional icon and text. |
| [CometChatUsers](/docs/ui-kit/angular/v4/users) | This component the list of users                                |

***

## Usage

### Integration

The following code snippet illustrates how you can directly incorporate the Add Members component into your Application.

<Tabs>
  <Tab title="app.module.ts">
    ```ts theme={null}
    import { CUSTOM_ELEMENTS_SCHEMA, NgModule } from "@angular/core";
    import { BrowserModule } from "@angular/platform-browser";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-angular";
    import { AppComponent } from "./app.component";

    @NgModule({
      imports: [BrowserModule, CometChatAddMembers],
      declarations: [AppComponent],
      providers: [],
      bootstrap: [AppComponent],
      schemas: [CUSTOM_ELEMENTS_SCHEMA],
    })
    export class AppModule {}
    ```
  </Tab>

  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
      ></cometchat-add-members>
    </div>
    ```
  </Tab>
</Tabs>

***

### Actions

[Actions](/docs/ui-kit/angular/v4/components-overview#actions) dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.

##### 1. onSelect

The `onSelect` action is activated when you select the done icon while in selection mode. This returns a list of all the users that you have selected.

This action does not come with any predefined behavior. However, you have the flexibility to override this event and tailor it to suit your needs using the following code snippet.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      public handleOnSelect = (user: CometChat.User, selected: boolean): void => {
        console.log("Custom on select action", user, selected);
      };
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [onSelect]="handleOnSelect"
      ></cometchat-add-members>
    </div>
    ```
  </Tab>
</Tabs>

##### 2. onAddMembersButtonClick

The `onAddMembersButtonClick` action is triggered when you click the add member button after choosing the users you wish to add in the group. By default, it returns the group GUID and an array of members to be added. However, you have the flexibility to override this event and tailor it to suit your needs using the following code snippet.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      public handleOnAddMembersButtonClick = (guid: string, members: CometChat.User[]) => {
        console.log("youc custom on add members button click actions");
      };
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [onAddMembersButtonClick]="handleOnAddMembersButtonClick"
      ></cometchat-add-members>
    </div>
    ```
  </Tab>
</Tabs>

##### 3. OnBack

`OnBack` is triggered when you click on the back button of the Add Members component. You can override this action using the following code snippet.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      public handleOnBack = () => {
        console.log("Your custom on back action");
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [onBack]="handleOnBack"
      ></cometchat-add-members>
    </div>
    ```
  </Tab>
</Tabs>

##### 4. onClose

`onClose` is triggered when you click on the close button of the Add Members component. You can override this action using the following code snippet.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      public handleOnClose = () => {
        console.log("Your custom on close actions");
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [onClose]="handleOnClose"
      ></cometchat-add-members>
    </div>
    ```
  </Tab>
</Tabs>

##### 5. onError

This action doesn't change the behavior of the component but rather listens for any errors that occur in the Add Members component.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      public handleOnError = (error: CometChat.CometChatException) => {
        console.log("your custom on error action", error);
      };
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [onError]="handleOnError"
      ></cometchat-add-members>
    </div>
    ```
  </Tab>
</Tabs>

***

### Filters

**Filters** allow you to customize the data displayed in a list within a Component. You can filter the list based on your specific criteria, allowing for a more customized. Filters can be applied using RequestBuilders of Chat SDK.

##### 1. UsersRequestBuilder

The [UsersRequestBuilder](/docs/sdk/javascript/retrieve-users) enables you to filter and customize the users list based on available parameters in UsersRequestBuilder. This feature allows you to create more specific and targeted queries when fetching users. The following are the parameters available in [UsersRequestBuilder](/docs/sdk/javascript/retrieve-users)

| Methods              | Type          | Description                                                                               |
| -------------------- | ------------- | ----------------------------------------------------------------------------------------- |
| **setLimit**         | number        | sets the number of users that can be fetched in a single request, suitable for pagination |
| **setSearchKeyword** | String        | used for fetching users matching the passed string                                        |
| **hideBlockedUsers** | boolean       | used for fetching all those users who are not blocked by the logged in user               |
| **friendsOnly**      | boolean       | used for fetching only those users in which logged in user is a member                    |
| **setRoles**         | List\<String> | used for fetching users containing the passed tags                                        |
| **setTags**          | List\<String> | used for fetching users containing the passed tags                                        |
| **withTags**         | boolean       | used for fetching users containing tags                                                   |
| **setStatus**        | String        | used for fetching users by their status online or offline                                 |
| **setUIDs**          | List\<String> | used for fetching users containing the passed users                                       |

**Example**

In the example below, we are applying a filter to the UserList by setting the limit to eight and sorting the lists by their name.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      usersRequestBuilder = new CometChat.UsersRequestBuilder().setLimit(8).sortBy("name");
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [usersRequestBuilder]="usersRequestBuilder"
      ></cometchat-add-members>
    </div>
    ```
  </Tab>
</Tabs>

##### 2. SearchRequestBuilder

The SearchRequestBuilder uses [UserRequestBuilder](/docs/sdk/javascript/retrieve-users) enables you to filter and customize the search list based on available parameters in UserRequestBuilder. This feature allows you to keep uniformity between the displayed UserList and searched UserList.

**Example**

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      searchRequestBuilder = new CometChat.UsersRequestBuilder().setLimit(8).setSearchKeyword("**")
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [searchRequestBuilder]="searchRequestBuilder"
      ></cometchat-add-members>
    </div>
    ```
  </Tab>
</Tabs>

***

### Events

[Events](/docs/ui-kit/angular/v4/components-overview#events) are emitted by a `Component`. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed.

Events emitted by the Add Members component is as follows.

| Event                  | Description                                        |
| ---------------------- | -------------------------------------------------- |
| **ccGroupMemberAdded** | Triggers when a user added to a group successfully |

<Tabs>
  <Tab title="TypeScript">
    ```ts theme={null}
    import {CometChatGroupEvents} from "@cometchat/chat-uikit-angular";

    this.ccGroupMemberAdded = CometChatGroupEvents.ccGroupMemberAdded.subscribe(
      (item: IGroupMemberAdded) => {
            // Your Code
      }
    );
    ```
  </Tab>
</Tabs>

***

Removing `CometChatGroupEvents` Listener's

<Tabs>
  <Tab title="TypeScript">
    ```ts theme={null}
    this.ccGroupMemberAdded.unsubscribe();
    ```
  </Tab>
</Tabs>

***

## Customization

To fit your app's design requirements, you can customize the appearance of the Add Members component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

### Style

Using **Style** you can **customize** the look and feel of the component in your app, These parameters typically control elements such as the **color**, **size**, **shape**, and **fonts** used within the component.

##### 1. AddMembers Style

You can set the `AddMembersStyle` to the Add Members Component to customize the styling.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/tiy_c-4NywbKIGIr/images/7b9f11c8-add_members_style_web_screens-586b5e956c010ee2878e9b8ffae02e24.png?fit=max&auto=format&n=tiy_c-4NywbKIGIr&q=85&s=21eccbaed1c02e61f4fe96750e9f5e91" width="3600" height="2400" data-path="images/7b9f11c8-add_members_style_web_screens-586b5e956c010ee2878e9b8ffae02e24.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { AddMembersStyle } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      addMembersStyle = new AddMembersStyle({
        addMembersButtonBackground: "#6716c9",
        addMembersButtonTextColor: "#ffffff",
        background: "#d6b9fa",
        searchBackground: "#6716c9",
        searchPlaceholderTextColor: "#ffffff",
        titleTextColor: "#ffffff",
        searchIconTint: "#ffffff",
        separatorColor: "#6716c9",
        sectionHeaderTextColor: "#ffffff",
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [addMembersStyle]="addMembersStyle"
      ></cometchat-add-members>
    </div>
    ```
  </Tab>
</Tabs>

List of properties exposed by AddMembersStyle:

| Property                       | Description                                     | Code                                   |
| ------------------------------ | ----------------------------------------------- | -------------------------------------- |
| **border**                     | Used to set border                              | `border?: string,`                     |
| **borderRadius**               | Used to set border radius                       | `borderRadius?: string;`               |
| **background**                 | Used to set background colour                   | `background?: string;`                 |
| **height**                     | Used to set height                              | `height?: string;`                     |
| **width**                      | Used to set width                               | `width?: string;`                      |
| **titleTextFont**              | Used to set title text font                     | `titleTextFont?: string,`              |
| **titleTextColor**             | Used to set title text color                    | `titleTextColor?: string;`             |
| **searchPlaceholderTextFont**  | Used to set search placeholder font             | `searchPlaceholderTextFont?: string;`  |
| **searchPlaceholderTextColor** | Used to set search placeholder color            | `searchPlaceholderTextColor?: string;` |
| **searchTextFont**             | Used to set search text font                    | `searchTextFont?: string;`             |
| **searchTextColor**            | Used to set search text color                   | `searchTextColor?: string;`            |
| **emptyStateTextFont**         | Used to set empty state text font               | `emptyStateTextFont?: string;`         |
| **emptyStateTextColor**        | Used to set empty state text color              | `emptyStateTextColor?: string;`        |
| **errorStateTextFont**         | Used to set error state text font               | `errorStateTextFont?: string;`         |
| **errorStateTextColor**        | Used to set error state text color              | `errorStateTextColor?: string;`        |
| **loadingIconTint**            | Used to set loading icon tint                   | `loadingIconTint?: string;`            |
| **searchIconTint**             | Used to set search icon tint                    | `searchIconTint?: string;`             |
| **searchBorder**               | Used to set search border                       | `searchBorder?: string;`               |
| **searchBorderRadius**         | Used to set search border radius                | `searchBorderRadius?: string;`         |
| **searchBackground**           | Used to set search background color             | `searchBackground?: string;`           |
| **onlineStatusColor**          | Used to set online status color                 | `onlineStatusColor?: string;`          |
| **separatorColor**             | Used to set separator color                     | `separatorColor?: string;`             |
| **sectionHeaderTextFont**      | Used to set section header text font            | `sectionHeaderTextFont?: string;`      |
| **sectionHeaderTextColor**     | Used to set section header text color           | `sectionHeaderTextColor?: string;`     |
| **boxShadow**                  | Used to set box shadow                          | `boxShadow?: string;`                  |
| **backButtonIconTint**         | Used to set back button icon tint               | `backButtonIconTint?: string;`         |
| **closeButtonIconTint**        | Used to set close button icon tint              | `closeButtonIconTint?: string;`        |
| **addMembersButtonBackground** | Used to set add members button background color | `addMembersButtonBackground?: string;` |
| **addMembersButtonTextColor**  | Used to set add members button text color       | `addMembersButtonTextColor?: string;`  |
| **addMembersButtonTextFont**   | Used to set add members button text font        | `addMembersButtonTextFont?: string;`   |
| **padding**                    | Used to set padding                             | `padding?: string;`                    |

##### 2. Avatar Style

To apply customized styles to the `Avatar` component in the Add Members Component, you can use the following code snippet. For further insights on `Avatar` Styles [refer](/docs/ui-kit/angular/v4/avatar#avatar-style)

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, AvatarStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      avatarStyle = new AvatarStyle({
        backgroundColor: "#cdc2ff",
        border: "2px solid #6745ff",
        borderRadius: "10px",
        outerViewBorderColor: "#ca45ff",
        outerViewBorderRadius: "5px",
        nameTextColor: "#4554ff"
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [avatarStyle]="avatarStyle"
      ></cometchat-add-members>
    </div>
    ```
  </Tab>
</Tabs>

***

##### 3. LisItem Style

To apply customized styles to the `List Item` component in the `Add Members` Component, you can use the following code snippet. For further insights on `List Item` Styles [refer](/docs/ui-kit/angular/v4/list-item)

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, ListItemStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      listItemStyle: ListItemStyle = new ListItemStyle({
        background: "transparent",
        padding: "5px",
        border: "1px solid #e9b8f5",
        titleColor: "#8830f2",
        borderRadius: "20px",
        width: "100% !important"
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [listItemStyle]="listItemStyle"
      ></cometchat-add-members>
    </div>
    ```
  </Tab>
</Tabs>

##### 4. StatusIndicator Style

To apply customized styles to the Status Indicator component in the Add Members Component, You can use the following code snippet. For further insights on Status Indicator Styles [refer](/docs/ui-kit/angular/v4/status-indicator)

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      statusIndicatorStyle: any = ({
        height: '20px',
        width: '20px',
        backgroundColor: 'red'
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [StatusIndicatorStyle]="statusIndicatorStyle"
      ></cometchat-add-members>
    </div>
    ```
  </Tab>
</Tabs>

***

### Functionality

These are a set of small functional customizations that allow you to fine-tune the overall experience of the component. With these, you can change text, set custom icons, and toggle the visibility of UI elements.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { TitleAlignment } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      titleAlignment = TitleAlignment.left;
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [title]="'Your Custom Title'"
        [buttonText]="'Your Custom Button Text'"
        [titleAlignment]="titleAlignment"
      ></cometchat-add-members>
    </div>
    ```
  </Tab>
</Tabs>

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/F0pRX00dbgkztAbW/images/136d0887-add_members_functionality_default_web_screens-9d89f48785039204430f9429a3f3128e.png?fit=max&auto=format&n=F0pRX00dbgkztAbW&q=85&s=491d5646089feaccb0cd05b8e5a0a6ce" width="3600" height="2400" data-path="images/136d0887-add_members_functionality_default_web_screens-9d89f48785039204430f9429a3f3128e.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Xbd1mrZiWe1Pd3HE/images/90538c7e-add_members_functionality_custom_web_screens-fe3053bc5a70d1fe5b2f42b6d1a47929.png?fit=max&auto=format&n=Xbd1mrZiWe1Pd3HE&q=85&s=b95fab3e886bd8aa64acad9b615819cd" width="3600" height="2400" data-path="images/90538c7e-add_members_functionality_custom_web_screens-fe3053bc5a70d1fe5b2f42b6d1a47929.png" />
</Frame>

Below is a list of customizations along with corresponding code snippets

| Property                                                        | Description                                                                                      | Code                                                |
| --------------------------------------------------------------- | ------------------------------------------------------------------------------------------------ | --------------------------------------------------- |
| **title** <Tooltip tip="Not available">🛑</Tooltip>             | Used to set title in the app heading                                                             | `[title]="'Your Custom Title'"`                     |
| **buttonText** <Tooltip tip="Not available">🛑</Tooltip>        | Used to set a custom button text for the add members button                                      | `[buttonText]="'your custom button text'"`          |
| **errorStateText** <Tooltip tip="Not available">🛑</Tooltip>    | Used to set a custom text response when some error occurs on fetching the list of users          | `[errorStateText]="'your custom error state text'"` |
| **emptyStateText** <Tooltip tip="Not available">🛑</Tooltip>    | Used to set a custom text response when fetching the users has returned an empty list            | `[emptyStateText]="'your custom empty state text'"` |
| **searchPlaceholder** <Tooltip tip="Not available">🛑</Tooltip> | Used to set custom search placeholder text                                                       | `[searchPlaceholder]="'Custom Search PlaceHolder'"` |
| **searchIconURL**                                               | Used to set search Icon in the search field                                                      | `[searchIconURL]="searchIconURL"`                   |
| **loadingIconURL**                                              | Used to set loading Icon                                                                         | `[loadingIconURL]="loadingIconURL"`                 |
| **closeButtonIconURL**                                          | Used to set close button Icon                                                                    | `[closeButtonIconURL]="closeButtonIconURL"`         |
| **backButtonIconURL**                                           | Used to set the back button Icon                                                                 | `[backButtonIconURL]="backButtonIconURL"`           |
| **hideError**                                                   | Used to hide error on fetching users                                                             | `[hideError]="true"`                                |
| **hideSearch**                                                  | Used to toggle visibility for search box                                                         | `[hideSearch]="true"`                               |
| **hideSeparator**                                               | Used to hide the divider separating the user items                                               | `[hideSeparator]="true"`                            |
| **disableUsersPresence**                                        | Used to toggle functionality to show user's presence                                             | `[disableUsersPresence]="true"`                     |
| **showBackButton**                                              | Hides / shows the back button as per the boolean value                                           | `[showBackButton]="true"`                           |
| **sectionHeaderField**                                          | used to extract the section header character from the user object and show on the section header | `[sectionHeaderField]="sectionHeaderField"`         |
| **showSectionHeader**                                           | Hides / shows the section header as per the boolean value                                        | `[showSectionHeader]="true"`                        |
| **selectionMode**                                               | set the number of users that can be selected, SelectionMode can be single, multiple or none.     | `[selectionMode]="selectionMode"`                   |
| **titleAlignment**                                              | Alignment of the heading text for the component                                                  | `[titleAlignment]="titleAlignment"`                 |
| **group** <Tooltip tip="Not available">🛑</Tooltip>             | Used to pass group object of which group members will be shown                                   | `[group]="groupObject"`                             |

***

### Advance

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your views, layouts, and UI elements and then incorporate those into the component.

***

#### ListItemView

With this property, you can assign a custom ListItem to the Add Members Component.

**Example**

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/czi9y0KbDwCW-4OY/images/6fda7a43-add_members_listitemview_default_web_screens-69708b39626cf7c35e9c3c24691b60f5.png?fit=max&auto=format&n=czi9y0KbDwCW-4OY&q=85&s=d0a1eb8a8765e55154a777524736471f" width="3600" height="2400" data-path="images/6fda7a43-add_members_listitemview_default_web_screens-69708b39626cf7c35e9c3c24691b60f5.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/vk8kXY4T6hhH4l00/images/6c9dd84f-add_members_listitemview_custom_web_screens-f11310434eaea1de4ffc84d6c3d2c955.png?fit=max&auto=format&n=vk8kXY4T6hhH4l00&q=85&s=0da6ca55266d7b99c04d1e204498973e" width="3600" height="2400" data-path="images/6c9dd84f-add_members_listitemview_custom_web_screens-f11310434eaea1de4ffc84d6c3d2c955.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [listItemView]="listItemViewTemplate"
      ></cometchat-add-members>
    </div>
    <ng-template #listItemViewTemplate let-user>
      <div
        [ngStyle]="{
          display: 'flex',
          alignItems: 'left',
          padding: '10px',
          border: '2px solid #e9baff',
          borderRadius: '20px',
          background: '#ffffff'
        }"
      >
        <cometchat-avatar
          [image]="user.getAvatar()"
          [name]="user.getName()"
        ></cometchat-avatar>
        <div [ngStyle]="{ display: 'flex', paddingLeft: '10px' }">
          <div
            [ngStyle]="{
              fontWeight: 'bold',
              color: '#937aff',
              fontSize: '14px',
              marginTop: '5px'
            }"
          >
            {{ user.getName() }}
            <div
              [ngStyle]="{
                color: '#cfc4ff',
                fontSize: '10px',
                textAlign: 'left'
              }"
            >
              {{ user.getStatus() }}
            </div>
          </div>
        </div>
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### SubtitleView

You can customize the subtitle view for each users to meet your requirements

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/LKT8U_07JOWQgTZK/images/0e8e7ccf-add_members_subtitleview_default_web_screens-1349c4ce85da4a0262b74367cfc5c272.png?fit=max&auto=format&n=LKT8U_07JOWQgTZK&q=85&s=0566a4cca225f22243cb7e5e754d5be9" width="3600" height="2400" data-path="images/0e8e7ccf-add_members_subtitleview_default_web_screens-1349c4ce85da4a0262b74367cfc5c272.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Relz_yItqW5RHUsU/images/51153026-add_members_subtitleview_custom_web_screens-4f56bccf29b55225ecaaa25d899a1815.png?fit=max&auto=format&n=Relz_yItqW5RHUsU&q=85&s=d1698da9e2626300b79f576e42ad444d" width="3600" height="2400" data-path="images/51153026-add_members_subtitleview_custom_web_screens-4f56bccf29b55225ecaaa25d899a1815.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [subtitleView]="subtitleTemplate"
      ></cometchat-add-members>
    </div>
    <ng-template #subtitleTemplate>
      <div
        style="display: flex; align-items: left; padding: 10px; font-size: 10px;"
      >
        your custom subtitle view
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

#### LoadingStateView

You can set a custom loader view using `loadingStateView` to match the loading view of your app.

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Mh-tK73gC5erLrBQ/images/f8219de6-add_members_loadingview_default_web_screens-042ab9499803ff626ff79bbefc6b7d93.png?fit=max&auto=format&n=Mh-tK73gC5erLrBQ&q=85&s=168344527b644285695258ac1afdd774" width="3600" height="2400" data-path="images/f8219de6-add_members_loadingview_default_web_screens-042ab9499803ff626ff79bbefc6b7d93.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/L67V-UjCgqzL1qxp/images/72f67234-add_members_loadingview_custom_web_screens-d1860699d0902b9633bd5f99ff508abc.png?fit=max&auto=format&n=L67V-UjCgqzL1qxp&q=85&s=3b7a9a2b3cfaf3956bab23ec03442be5" width="3600" height="2400" data-path="images/72f67234-add_members_loadingview_custom_web_screens-d1860699d0902b9633bd5f99ff508abc.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, LoaderStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }

      getLoaderStyle: LoaderStyle = new LoaderStyle({
        iconTint: "red",
        background: "transparent",
        height: "20px",
        width: "20px",
        border: "none",
        borderRadius: "0",
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [loadingStateView]="loadingStateView"
      ></cometchat-add-members>
    </div>
    <ng-template #loadingStateView>
      <cometchat-loader
        iconURL="icon"
        [loaderStyle]="getLoaderStyle"
      ></cometchat-loader>
    </ng-template>
    ```
  </Tab>
</Tabs>

#### EmptyStateView

You can set a custom `EmptyStateView` using `emptyStateView` to match the empty view of your app.

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/8YlylzCf9CehSaWO/images/ccd2e6d1-add_members_empty_stateview_default_web_screens-fc2679cbb4fc8b362cf844fddc4bdb33.png?fit=max&auto=format&n=8YlylzCf9CehSaWO&q=85&s=c933a7c47961a114cee7750af0cf3e44" width="3600" height="2400" data-path="images/ccd2e6d1-add_members_empty_stateview_default_web_screens-fc2679cbb4fc8b362cf844fddc4bdb33.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Mh-tK73gC5erLrBQ/images/f6403cc4-add_members_empty_stateview_custom_web_screens-47d75d8bd655453d6244b79547bbc674.png?fit=max&auto=format&n=Mh-tK73gC5erLrBQ&q=85&s=b15e071f1c9d59f75650e760dfcedb23" width="3600" height="2400" data-path="images/f6403cc4-add_members_empty_stateview_custom_web_screens-47d75d8bd655453d6244b79547bbc674.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }


      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [emptyStateView]="emptyStateView"
      ></cometchat-add-members>
    </div>
    <ng-template #emptyStateView>
      <div>Your Custom Empty State</div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### ErrorStateView

You can set a custom `ErrorStateView` using `errorStateView` to match the error view of your app.

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/_jsRdrzYcNj1bcHI/images/42b0fc28-add_members_error_stateview_default_web_screens-c985c0ba92a41de236ec4cc61ecc2593.png?fit=max&auto=format&n=_jsRdrzYcNj1bcHI&q=85&s=2d9498fa8fbc66e9c8a4a872ab85ead3" width="3600" height="2400" data-path="images/42b0fc28-add_members_error_stateview_default_web_screens-c985c0ba92a41de236ec4cc61ecc2593.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/RxKy5RgybeX-8GbH/images/1c1f0308-add_members_error_stateview_custom_web_screens-ba521a92a31c2c9d886bd7aea980026e.png?fit=max&auto=format&n=RxKy5RgybeX-8GbH&q=85&s=11d32b0e6c2a583a874f537132d4c50b" width="3600" height="2400" data-path="images/1c1f0308-add_members_error_stateview_custom_web_screens-ba521a92a31c2c9d886bd7aea980026e.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [errorStateView]="errorStateView"
      ></cometchat-add-members>
    </div>
    <ng-template #errorStateView>
      <div style="height: 100vh; width: 100vw">
        <img
          src="img"
          alt="error icon"
          style="height:100px; width: 100px; justify-content: center; margin-top: 250px; margin-right: 700px;"
        />
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### Menus

You can set the Custom Menu view to add more options to the Add Members component.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/y8uIEcRYKgfQIY6z/images/9cc051d4-add_members_menus_web_screens-819d48c26512328fc83958b587ed015e.png?fit=max&auto=format&n=y8uIEcRYKgfQIY6z&q=85&s=361bc4bcd62f28961492e48708e84cde" width="3600" height="2400" data-path="images/9cc051d4-add_members_menus_web_screens-819d48c26512328fc83958b587ed015e.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      handleReload(): void {
        window.location.reload();
      }

      getButtonStyle() {
        return {
          height: '20px',
          width: '20px',
          border: 'none',
          borderRadius: '0',
          background: 'transparent'
        };
      }
      getButtonIconStyle() {
        return {
          color: '#7E57C2'
        };
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [menu]="menuTemplate"
      ></cometchat-add-members>
    </div>
    <ng-template #menuTemplate>
      <div style="margin-right: 20px;">
        <button [ngStyle]="getButtonStyle()" (click)="handleReload()">
          <img src="img" [ngStyle]="getButtonIconStyle()" alt="Reload Icon" />
        </button>
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### Options

You can set the Custom options to the Add Members component.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/60KLvpM3Vx0byZeU/images/b65b8d18-add_members_options_web_screens-1271022dbc49fb6d4b57919c44860a62.png?fit=max&auto=format&n=60KLvpM3Vx0byZeU&q=85&s=1858d34321bd1851b73910f7453f8e98" width="3600" height="2400" data-path="images/b65b8d18-add_members_options_web_screens-1271022dbc49fb6d4b57919c44860a62.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { CometChatOption } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      public groupObject!: CometChat.Group;
      ngOnInit(): void {
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });
      }
      getOptions = (user: any) => {
        const customOptions = [
          new CometChatOption({
            id: "1",
            title: "Title",
            iconURL: icon,
            iconTint:'green',
            backgroundColor: "transparent",
            onClick: () => {
              console.log("Custom option clicked for user:", user);
            },
          }),
        ];
        return customOptions;
      };
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-add-members
        *ngIf="groupObject"
        [group]="groupObject"
        [options]="getOptions"
      ></cometchat-add-members>
    </div>
    ```
  </Tab>
</Tabs>

***


> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Add Members

> Add Members — CometChat documentation.

## Overview

`CometChatAddMembers` is a [Component](/ui-kit/react/v4/components-overview#components) that allows administrators or group owners to add new members to a specific group. It enables administrators or group owners to extend the membership of a group by adding new users to participate in the group's discussions and activities. By utilising this feature, administrators can manage group membership, and control access to group content. The administrator can select the desired users to be added to the group. This can be done by searching for specific users, selecting from a list of available users. The selected users will receive notifications to join the group.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/pIKiBC-6hdnqY01x/images/5397c96f-add_members_overview_web_screens-1349c4ce85da4a0262b74367cfc5c272.png?fit=max&auto=format&n=pIKiBC-6hdnqY01x&q=85&s=8b8b808b60cf38b133ed839dcf2d7fca" width="3600" height="2400" data-path="images/5397c96f-add_members_overview_web_screens-1349c4ce85da4a0262b74367cfc5c272.png" />
</Frame>

The Add Members component is composed of the following Components:

| Components                               | Description                                                     |
| ---------------------------------------- | --------------------------------------------------------------- |
| cometchat-button                         | This component represents a button with optional icon and text. |
| [CometChatUsers](/ui-kit/react/v4/users) | This component the list of users                                |

***

## Usage

### Integration

The following code snippet illustrates how you can directly incorporate the Add Members component into your Application.

<Tabs>
  <Tab title="AddMembersDemo.tsx">
    ```typescript theme={null}

    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { CometChatAddMembers } from '@cometchat/chat-uikit-react'
    import React from 'react'

    const AddMembersDemo = () => {

        const [chatGroup, setChatGroup] = React.useState<CometChat.Group | undefined>();

        React.useEffect(() => {
            CometChat.getGroup("uid").then((group) => {
                setChatGroup(group);
            })
        }, []);
        return (
            <>
                {
                    chatGroup &&
                    <CometChatAddMembers
                        group={chatGroup}
                    />
                }
            </>
        )
    }

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="App.tsx">
    ```typescript theme={null}
    import { AddMembersDemo } from "./AddMembersDemo";

    export default function App() {
      return (
        <div className="App">
          <AddMembersDemo />
        </div>
      );
    }
    ```
  </Tab>
</Tabs>

***

### Actions

[Actions](/ui-kit/react/v4/components-overview#actions) dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.

#### 1. onSelect

The `onSelect` action is activated when you select the done icon while in selection mode. This returns a list of all the users that you have selected.

This action does not come with any predefined behavior. However, you have the flexibility to override this event and tailor it to suit your needs using the following code snippet.

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      function handleOnSelect(user: CometChat.User, selected: boolean): void {
        console.log(user);
        //your custom onSelect actions
      }
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} onSelect={handleOnSelect} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      function handleOnSelect(user, selected) {
        console.log(user);
        //your custom onSelect actions
      }
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} onSelect={handleOnSelect} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

#### 2. onAddMembersButtonClick

The `onAddMembersButtonClick` action is triggered when you click the add member button after choosing the users you wish to add in the group. By default, it returns the group GUID and an array of members to be added. However, you have the flexibility to override this event and tailor it to suit your needs using the following code snippet.

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      function handleOnAddMembersButtonClick(
        guid: string,
        membersToAdd: CometChat.GroupMember[]
      ): void {
        //your custom add member button click actions
      }
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              onAddMembersButtonClick={handleOnAddMembersButtonClick}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      function handleOnAddMembersButtonClick(guid, membersToAdd) {
        //your custom add member button click actions
      }
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              onAddMembersButtonClick={handleOnAddMembersButtonClick}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

#### 3. OnBack

`OnBack` is triggered when you click on the back button of the Add Members component. You can override this action using the following code snippet.

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      function handleOnBack(): void {
        //Your Custom onBack actions
      }
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} onBack={handleOnBack} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      function handleOnBack() {
        //Your Custom onBack actions
      }
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} onBack={handleOnBack} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

#### 4. onClose

`onClose` is triggered when you click on the close button of the Add Members component. You can override this action using the following code snippet.

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      function handleOnClose(): void {
        //Your Custom onClose actions
      }
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} onClose={handleOnClose} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      function handleOnClose() {
        //Your Custom onClose actions
      }
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} onClose={handleOnClose} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

#### 5. onError

This action doesn't change the behavior of the component but rather listens for any errors that occur in the Add Members component.

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      function handleOnError(error: CometChat.CometChatException): void {
        //Your Custom onError actions
      }
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} onError={handleOnError} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      function handleOnError(error) {
        //Your Custom onError actions
      }
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} onError={handleOnError} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

***

### Filters

**Filters** allow you to customize the data displayed in a list within a Component. You can filter the list based on your specific criteria, allowing for a more customized. Filters can be applied using RequestBuilders of Chat SDK.

#### 1. UsersRequestBuilder

The [UsersRequestBuilder](/sdk/javascript/retrieve-users) enables you to filter and customize the users list based on available parameters in UsersRequestBuilder. This feature allows you to create more specific and targeted queries when fetching users. The following are the parameters available in [UsersRequestBuilder](/sdk/javascript/retrieve-users)

| Methods              | Type          | Description                                                                               |
| -------------------- | ------------- | ----------------------------------------------------------------------------------------- |
| **setLimit**         | number        | sets the number of users that can be fetched in a single request, suitable for pagination |
| **setSearchKeyword** | String        | used for fetching users matching the passed string                                        |
| **hideBlockedUsers** | boolean       | used for fetching all those users who are not blocked by the logged in user               |
| **friendsOnly**      | boolean       | used for fetching only those users in which logged in user is a member                    |
| **setRoles**         | List\<String> | used for fetching users containing the passed tags                                        |
| **setTags**          | List\<String> | used for fetching users containing the passed tags                                        |
| **withTags**         | boolean       | used for fetching users containing tags                                                   |
| **setStatus**        | String        | used for fetching users by their status online or offline                                 |
| **setUIDs**          | List\<String> | used for fetching users containing the passed users                                       |

**Example**

In the example below, we are applying a filter to the UserList by setting the limit to eight and sorting the lists by their name.

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              usersRequestBuilder={new CometChat.UsersRequestBuilder()
                .setLimit(8)
                .sortBy("name")}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              usersRequestBuilder={new CometChat.UsersRequestBuilder()
                .setLimit(8)
                .sortBy("name")}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

#### 2. SearchRequestBuilder

The SearchRequestBuilder uses [UserRequestBuilder](/sdk/javascript/retrieve-users) enables you to filter and customize the search list based on available parameters in UserRequestBuilder. This feature allows you to keep uniformity between the displayed UserList and searched UserList.

**Example**

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              searchRequestBuilder={new CometChat.UsersRequestBuilder()
                .setLimit(8)
                .setSearchKeyword("**")}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              searchRequestBuilder={new CometChat.UsersRequestBuilder()
                .setLimit(8)
                .setSearchKeyword("**")}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

***

### Events

[Events](/ui-kit/react/v4/components-overview#events) are emitted by a `Component`. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed.

Events emitted by the Add Members component is as follows.

| Event                  | Description                                        |
| ---------------------- | -------------------------------------------------- |
| **ccGroupMemberAdded** | Triggers when a user added to a group successfully |

<Tabs>
  <Tab title="Add Listener">
    ```javascript theme={null}
    const ccGroupMemberAdded = CometChatGroupEvents.ccGroupMemberAdded.subscribe(
      (item: IGroupMemberAdded) => {
        //Your Code
      }
    );
    ```
  </Tab>
</Tabs>

***

<Tabs>
  <Tab title="Remove Listener">
    ```javascript theme={null}
    ccGroupMemberAdded?.unsubscribe();
    ```
  </Tab>
</Tabs>

***

## Customization

To fit your app's design requirements, you can customize the appearance of the Add Members component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

### Style

Using **Style** you can **customize** the look and feel of the component in your app, These parameters typically control elements such as the **color**, **size**, **shape**, and **fonts** used within the component.

#### 1. AddMembers Style

You can set the `AddMembersStyle` to the Add Members Component to customize the styling.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/tiy_c-4NywbKIGIr/images/7b9f11c8-add_members_style_web_screens-586b5e956c010ee2878e9b8ffae02e24.png?fit=max&auto=format&n=tiy_c-4NywbKIGIr&q=85&s=21eccbaed1c02e61f4fe96750e9f5e91" width="3600" height="2400" data-path="images/7b9f11c8-add_members_style_web_screens-586b5e956c010ee2878e9b8ffae02e24.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatAddMembers,
      AddMembersStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const addMembersStyle = new AddMembersStyle({
        addMembersButtonBackground: "#6716c9",
        addMembersButtonTextColor: "#ffffff",
        background: "#d6b9fa",
        searchBackground: "#6716c9",
        searchPlaceholderTextColor: "#ffffff",
        titleTextColor: "#ffffff",
        searchIconTint: "#ffffff",
        separatorColor: "#6716c9",
        sectionHeaderTextColor: "#ffffff",
      });
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              addMembersStyle={addMembersStyle}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatAddMembers,
      AddMembersStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const addMembersStyle = new AddMembersStyle({
        addMembersButtonBackground: "#6716c9",
        addMembersButtonTextColor: "#ffffff",
        background: "#d6b9fa",
        searchBackground: "#6716c9",
        searchPlaceholderTextColor: "#ffffff",
        titleTextColor: "#ffffff",
        searchIconTint: "#ffffff",
        separatorColor: "#6716c9",
        sectionHeaderTextColor: "#ffffff",
      });
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              addMembersStyle={addMembersStyle}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

List of properties exposed by AddMembersStyle:

| Property                       | Description                                     | Code                                   |
| ------------------------------ | ----------------------------------------------- | -------------------------------------- |
| **border**                     | Used to set border                              | `border?: string,`                     |
| **borderRadius**               | Used to set border radius                       | `borderRadius?: string;`               |
| **background**                 | Used to set background colour                   | `background?: string;`                 |
| **height**                     | Used to set height                              | `height?: string;`                     |
| **width**                      | Used to set width                               | `width?: string;`                      |
| **titleTextFont**              | Used to set title text font                     | `titleTextFont?: string,`              |
| **titleTextColor**             | Used to set title text color                    | `titleTextColor?: string;`             |
| **searchPlaceholderTextFont**  | Used to set search placeholder font             | `searchPlaceholderTextFont?: string;`  |
| **searchPlaceholderTextColor** | Used to set search placeholder color            | `searchPlaceholderTextColor?: string;` |
| **searchTextFont**             | Used to set search text font                    | `searchTextFont?: string;`             |
| **searchTextColor**            | Used to set search text color                   | `searchTextColor?: string;`            |
| **emptyStateTextFont**         | Used to set empty state text font               | `emptyStateTextFont?: string;`         |
| **emptyStateTextColor**        | Used to set empty state text color              | `emptyStateTextColor?: string;`        |
| **errorStateTextFont**         | Used to set error state text font               | `errorStateTextFont?: string;`         |
| **errorStateTextColor**        | Used to set error state text color              | `errorStateTextColor?: string;`        |
| **loadingIconTint**            | Used to set loading icon tint                   | `loadingIconTint?: string;`            |
| **searchIconTint**             | Used to set search icon tint                    | `searchIconTint?: string;`             |
| **searchBorder**               | Used to set search border                       | `searchBorder?: string;`               |
| **searchBorderRadius**         | Used to set search border radius                | `searchBorderRadius?: string;`         |
| **searchBackground**           | Used to set search background color             | `searchBackground?: string;`           |
| **onlineStatusColor**          | Used to set online status color                 | `onlineStatusColor?: string;`          |
| **separatorColor**             | Used to set separator color                     | `separatorColor?: string;`             |
| **sectionHeaderTextFont**      | Used to set section header text font            | `sectionHeaderTextFont?: string;`      |
| **sectionHeaderTextColor**     | Used to set section header text color           | `sectionHeaderTextColor?: string;`     |
| **boxShadow**                  | Used to set box shadow                          | `boxShadow?: string;`                  |
| **backButtonIconTint**         | Used to set back button icon tint               | `backButtonIconTint?: string;`         |
| **closeButtonIconTint**        | Used to set close button icon tint              | `closeButtonIconTint?: string;`        |
| **addMembersButtonBackground** | Used to set add members button background color | `addMembersButtonBackground?: string;` |
| **addMembersButtonTextColor**  | Used to set add members button text color       | `addMembersButtonTextColor?: string;`  |
| **addMembersButtonTextFont**   | Used to set add members button text font        | `addMembersButtonTextFont?: string;`   |
| **padding**                    | Used to set padding                             | `padding?: string;`                    |

#### 2. Avatar Style

To apply customized styles to the `Avatar` component in the Add Members Component, you can use the following code snippet. For further insights on `Avatar` Styles [refer](/ui-kit/react/v4/avatar#avatar-style)

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers, AvatarStyle } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const avatarStyle = new AvatarStyle({
        backgroundColor: "#cdc2ff",
        border: "2px solid #6745ff",
        borderRadius: "10px",
        outerViewBorderColor: "#ca45ff",
        outerViewBorderRadius: "5px",
        nameTextColor: "#4554ff",
      });
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} avatarStyle={avatarStyle} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers, AvatarStyle } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const avatarStyle = new AvatarStyle({
        backgroundColor: "#cdc2ff",
        border: "2px solid #6745ff",
        borderRadius: "10px",
        outerViewBorderColor: "#ca45ff",
        outerViewBorderRadius: "5px",
        nameTextColor: "#4554ff",
      });
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} avatarStyle={avatarStyle} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

#### 3. LisItem Style

To apply customized styles to the `ListItemStyle` component in the `Add Members` Component, you can use the following code snippet. For further insights on `ListItemStyle` Styles [refer](/ui-kit/react/v4/list-item)

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatAddMembers,
      ListItemStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const listItemStyle = new ListItemStyle({
        width: "100%",
        height: "100%",
        border: "2px solid #cdc2ff",
      });
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} listItemStyle={listItemStyle} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatAddMembers,
      ListItemStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const listItemStyle = new ListItemStyle({
        width: "100%",
        height: "100%",
        border: "2px solid #cdc2ff",
      });
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} listItemStyle={listItemStyle} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

#### 4. StatusIndicator Style

To apply customized styles to the Status Indicator component in the Add Members Component, You can use the following code snippet. For further insights on Status Indicator Styles [refer](/ui-kit/react/v4/status-indicator)

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const statusIndicatorStyle = {
        background: "#db35de",
        height: "10px",
        width: "10px",
      };
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              statusIndicatorStyle={statusIndicatorStyle}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const statusIndicatorStyle = {
        background: "#db35de",
        height: "10px",
        width: "10px",
      };
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              statusIndicatorStyle={statusIndicatorStyle}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

***

### Functionality

These are a set of small functional customizations that allow you to fine-tune the overall experience of the component. With these, you can change text, set custom icons, and toggle the visibility of UI elements.

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatAddMembers,
      TitleAlignment,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              title="Your Custom Title"
              buttonText="Your Custom Button Text"
              titleAlignment={TitleAlignment.left}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatAddMembers,
      TitleAlignment,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              title="Your Custom Title"
              buttonText="Your Custom Button Text"
              titleAlignment={TitleAlignment.left}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/F0pRX00dbgkztAbW/images/136d0887-add_members_functionality_default_web_screens-9d89f48785039204430f9429a3f3128e.png?fit=max&auto=format&n=F0pRX00dbgkztAbW&q=85&s=491d5646089feaccb0cd05b8e5a0a6ce" width="3600" height="2400" data-path="images/136d0887-add_members_functionality_default_web_screens-9d89f48785039204430f9429a3f3128e.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Xbd1mrZiWe1Pd3HE/images/90538c7e-add_members_functionality_custom_web_screens-fe3053bc5a70d1fe5b2f42b6d1a47929.png?fit=max&auto=format&n=Xbd1mrZiWe1Pd3HE&q=85&s=b95fab3e886bd8aa64acad9b615819cd" width="3600" height="2400" data-path="images/90538c7e-add_members_functionality_custom_web_screens-fe3053bc5a70d1fe5b2f42b6d1a47929.png" />
</Frame>

Below is a list of customizations along with corresponding code snippets

| Property                         | Description                                                                                      | Code                                              |
| -------------------------------- | ------------------------------------------------------------------------------------------------ | ------------------------------------------------- |
| **title** [report]()             | Used to set title in the app heading                                                             | `title="Your Custom Title"`                       |
| **buttonText** [report]()        | Used to set a custom button text for the add members button                                      | `buttonText="your custom button text"`            |
| **errorStateText** [report]()    | Used to set a custom text response when some error occurs on fetching the list of users          | `errorStateText="your custom error state text"`   |
| **emptyStateText** [report]()    | Used to set a custom text response when fetching the users has returned an empty list            | `emptyStateText="your custom empty state text"`   |
| **searchPlaceholder** [report]() | Used to set custom search placeholder text                                                       | `searchPlaceholder='Custom Search PlaceHolder'`   |
| **searchIconURL**                | Used to set search Icon in the search field                                                      | `searchIconURL="Your Custom search icon"`         |
| **loadingIconURL**               | Used to set loading Icon                                                                         | `loadingIconURL="your custom loading icon url"`   |
| **closeButtonIconURL**           | Used to set close button Icon                                                                    | `closeButtonIconURL="your custom close icon url"` |
| **backButtonIconURL**            | Used to set the back button Icon                                                                 | `backButtonIconURL='Your Custom back Icon'`       |
| **hideError**                    | Used to hide error on fetching users                                                             | `hideError={true}`                                |
| **hideSearch**                   | Used to toggle visibility for search box                                                         | `hideSearch={true}"`                              |
| **hideSeparator**                | Used to hide the divider separating the user items                                               | `hideSeparator={true}`                            |
| **disableUsersPresence**         | Used to toggle functionality to show user's presence                                             | `disableUsersPresence={true}`                     |
| **showBackButton**               | Hides / shows the back button as per the boolean value                                           | `showBackButton={true}`                           |
| **sectionHeaderField**           | used to extract the section header character from the user object and show on the section header | `sectionHeaderField={'getStatus'}`                |
| **showSectionHeader**            | Hides / shows the section header as per the boolean value                                        | `showSectionHeader={true}`                        |
| **selectionMode**                | set the number of users that can be selected, SelectionMode can be single, multiple or none.     | `selectionMode={SelectionMode.multiple}`          |
| **titleAlignment**               | Alignment of the heading text for the component                                                  | `titleAlignment={TitleAlignment.center}`          |
| **group** [report]()             | Used to pass group object of which group members will be shown                                   | `group={chatGroup}`                               |

***

### Advance

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your views, layouts, and UI elements and then incorporate those into the component.

***

#### ListItemView

With this property, you can assign a custom ListItem to the Add Members Component.

```
listItemView = { getListItemView };
```

**Example**

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/czi9y0KbDwCW-4OY/images/6fda7a43-add_members_listitemview_default_web_screens-69708b39626cf7c35e9c3c24691b60f5.png?fit=max&auto=format&n=czi9y0KbDwCW-4OY&q=85&s=d0a1eb8a8765e55154a777524736471f" width="3600" height="2400" data-path="images/6fda7a43-add_members_listitemview_default_web_screens-69708b39626cf7c35e9c3c24691b60f5.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/vk8kXY4T6hhH4l00/images/6c9dd84f-add_members_listitemview_custom_web_screens-f11310434eaea1de4ffc84d6c3d2c955.png?fit=max&auto=format&n=vk8kXY4T6hhH4l00&q=85&s=0da6ca55266d7b99c04d1e204498973e" width="3600" height="2400" data-path="images/6c9dd84f-add_members_listitemview_custom_web_screens-f11310434eaea1de4ffc84d6c3d2c955.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const getListItemView = (user: CometChat.User) => {
        return (
          <div
            style={{
              display: "flex",
              alignItems: "left",
              padding: "10px",
              border: "2px solid #e9baff",
              borderRadius: "20px",
              background: "#6e2bd9",
            }}
          >
            <cometchat-avatar image={user.getAvatar()} name={user.getName()} />

            <div style={{ display: "flex", paddingLeft: "10px" }}>
              <div
                style={{ fontWeight: "bold", color: "#ffffff", fontSize: "14px" }}
              >
                {user.getName()}
                <div
                  style={{ color: "#ffffff", fontSize: "10px", textAlign: "left" }}
                >
                  {user.getStatus()}
                </div>
              </div>
            </div>
          </div>
        );
      };
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} listItemView={getListItemView} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const getListItemView = (user) => {
        return (
          <div
            style={{
              display: "flex",
              alignItems: "left",
              padding: "10px",
              border: "2px solid #e9baff",
              borderRadius: "20px",
              background: "#6e2bd9",
            }}
          >
            <cometchat-avatar image={user.getAvatar()} name={user.getName()} />

            <div style={{ display: "flex", paddingLeft: "10px" }}>
              <div
                style={{ fontWeight: "bold", color: "#ffffff", fontSize: "14px" }}
              >
                {user.getName()}
                <div
                  style={{ color: "#ffffff", fontSize: "10px", textAlign: "left" }}
                >
                  {user.getStatus()}
                </div>
              </div>
            </div>
          </div>
        );
      };
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} listItemView={getListItemView} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

***

#### SubtitleView

You can customize the subtitle view for each users to meet your requirements

```javascript theme={null}
subtitleView = { getSubtitleView };
```

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/LKT8U_07JOWQgTZK/images/0e8e7ccf-add_members_subtitleview_default_web_screens-1349c4ce85da4a0262b74367cfc5c272.png?fit=max&auto=format&n=LKT8U_07JOWQgTZK&q=85&s=0566a4cca225f22243cb7e5e754d5be9" width="3600" height="2400" data-path="images/0e8e7ccf-add_members_subtitleview_default_web_screens-1349c4ce85da4a0262b74367cfc5c272.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Relz_yItqW5RHUsU/images/51153026-add_members_subtitleview_custom_web_screens-4f56bccf29b55225ecaaa25d899a1815.png?fit=max&auto=format&n=Relz_yItqW5RHUsU&q=85&s=d1698da9e2626300b79f576e42ad444d" width="3600" height="2400" data-path="images/51153026-add_members_subtitleview_custom_web_screens-4f56bccf29b55225ecaaa25d899a1815.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const getSubtitleView = (user: CometChat.User): JSX.Element => {
        function formatTime(timestamp: number) {
          const date = new Date(timestamp * 1000);
          return date.toLocaleString();
        }
        if (user instanceof CometChat.User) {
          return (
            <div
              style={{
                display: "flex",
                alignItems: "left",
                padding: "2px",
                fontSize: "10px",
              }}
            >
              <div style={{ color: "gray" }}>
                Last Active At: {formatTime(user.getLastActiveAt())}
              </div>
            </div>
          );
        } else {
          return <></>;
        }
      };
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} subtitleView={getSubtitleView} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const getSubtitleView = (user) => {
        function formatTime(timestamp) {
          const date = new Date(timestamp * 1000);
          return date.toLocaleString();
        }
        if (user instanceof CometChat.User) {
          return (
            <div
              style={{
                display: "flex",
                alignItems: "left",
                padding: "2px",
                fontSize: "10px",
              }}
            >
              <div style={{ color: "gray" }}>
                Last Active At: {formatTime(user.getLastActiveAt())}
              </div>
            </div>
          );
        } else {
          return <></>;
        }
      };
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} subtitleView={getSubtitleView} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

#### LoadingStateView

You can set a custom loader view using `loadingStateView` to match the loading view of your app.

```javascript theme={null}
loadingStateView={getLoadingStateView()}
```

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Mh-tK73gC5erLrBQ/images/f8219de6-add_members_loadingview_default_web_screens-042ab9499803ff626ff79bbefc6b7d93.png?fit=max&auto=format&n=Mh-tK73gC5erLrBQ&q=85&s=168344527b644285695258ac1afdd774" width="3600" height="2400" data-path="images/f8219de6-add_members_loadingview_default_web_screens-042ab9499803ff626ff79bbefc6b7d93.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/L67V-UjCgqzL1qxp/images/72f67234-add_members_loadingview_custom_web_screens-d1860699d0902b9633bd5f99ff508abc.png?fit=max&auto=format&n=L67V-UjCgqzL1qxp&q=85&s=3b7a9a2b3cfaf3956bab23ec03442be5" width="3600" height="2400" data-path="images/72f67234-add_members_loadingview_custom_web_screens-d1860699d0902b9633bd5f99ff508abc.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers, LoaderStyle } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const getLoadingStateView = () => {
        const getLoaderStyle = new LoaderStyle({
          iconTint: "#890aff",
          background: "transparent",
          height: "100vh",
          width: "100vw",
        });

        return (
          <cometchat-loader
            iconURL="icon"
            loaderStyle={JSON.stringify(getLoaderStyle)}
          ></cometchat-loader>
        );
      };
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              loadingStateView={getLoadingStateView()}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers, LoaderStyle } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const getLoadingStateView = () => {
        const getLoaderStyle = new LoaderStyle({
          iconTint: "#890aff",
          background: "transparent",
          height: "100vh",
          width: "100vw",
        });

        return (
          <cometchat-loader
            iconURL="icon"
            loaderStyle={JSON.stringify(getLoaderStyle)}
          ></cometchat-loader>
        );
      };
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              loadingStateView={getLoadingStateView()}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

#### EmptyStateView

You can set a custom `EmptyStateView` using `emptyStateView` to match the empty view of your app.

```javascript theme={null}
emptyStateView={getEmptyStateView()}
```

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/8YlylzCf9CehSaWO/images/ccd2e6d1-add_members_empty_stateview_default_web_screens-fc2679cbb4fc8b362cf844fddc4bdb33.png?fit=max&auto=format&n=8YlylzCf9CehSaWO&q=85&s=c933a7c47961a114cee7750af0cf3e44" width="3600" height="2400" data-path="images/ccd2e6d1-add_members_empty_stateview_default_web_screens-fc2679cbb4fc8b362cf844fddc4bdb33.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Mh-tK73gC5erLrBQ/images/f6403cc4-add_members_empty_stateview_custom_web_screens-47d75d8bd655453d6244b79547bbc674.png?fit=max&auto=format&n=Mh-tK73gC5erLrBQ&q=85&s=b15e071f1c9d59f75650e760dfcedb23" width="3600" height="2400" data-path="images/f6403cc4-add_members_empty_stateview_custom_web_screens-47d75d8bd655453d6244b79547bbc674.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const getEmptyStateView = () => {
        return (
          <div style={{ color: "#d6cfff", fontSize: "30px", font: "bold" }}>
            Your Custom Empty State
          </div>
        );
      };
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              emptyStateView={getEmptyStateView()}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const getEmptyStateView = () => {
        return (
          <div style={{ color: "#d6cfff", fontSize: "30px", font: "bold" }}>
            Your Custom Empty State
          </div>
        );
      };
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              emptyStateView={getEmptyStateView()}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

***

#### ErrorStateView

You can set a custom `ErrorStateView` using `errorStateView` to match the error view of your app.

```javascript theme={null}
errorSateView={getErrorStateView()}
```

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/_jsRdrzYcNj1bcHI/images/42b0fc28-add_members_error_stateview_default_web_screens-c985c0ba92a41de236ec4cc61ecc2593.png?fit=max&auto=format&n=_jsRdrzYcNj1bcHI&q=85&s=2d9498fa8fbc66e9c8a4a872ab85ead3" width="3600" height="2400" data-path="images/42b0fc28-add_members_error_stateview_default_web_screens-c985c0ba92a41de236ec4cc61ecc2593.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/RxKy5RgybeX-8GbH/images/1c1f0308-add_members_error_stateview_custom_web_screens-ba521a92a31c2c9d886bd7aea980026e.png?fit=max&auto=format&n=RxKy5RgybeX-8GbH&q=85&s=11d32b0e6c2a583a874f537132d4c50b" width="3600" height="2400" data-path="images/1c1f0308-add_members_error_stateview_custom_web_screens-ba521a92a31c2c9d886bd7aea980026e.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const getErrorStateView = () => {
        return (
          <div style={{ height: "100vh", width: "100vw" }}>
            <img
              src="image"
              alt="error icon"
              style={{
                height: "100px",
                width: "100px",
                marginTop: "250px",
                justifyContent: "center",
              }}
            ></img>
          </div>
        );
      };
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              errorStateView={getErrorStateView()}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const getErrorStateView = () => {
        return (
          <div style={{ height: "100vh", width: "100vw" }}>
            <img
              src="image"
              alt="error icon"
              style={{
                height: "100px",
                width: "100px",
                marginTop: "250px",
                justifyContent: "center",
              }}
            ></img>
          </div>
        );
      };
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              errorStateView={getErrorStateView()}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

***

#### Menus

You can set the Custom Menu view to add more options to the Add Members component.

```javascript theme={null}
menus={getMenus()}
```

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/y8uIEcRYKgfQIY6z/images/9cc051d4-add_members_menus_web_screens-819d48c26512328fc83958b587ed015e.png?fit=max&auto=format&n=y8uIEcRYKgfQIY6z&q=85&s=361bc4bcd62f28961492e48708e84cde" width="3600" height="2400" data-path="images/9cc051d4-add_members_menus_web_screens-819d48c26512328fc83958b587ed015e.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const getMenus = () => {
        const handleReload = () => {
          window.location.reload();
        };
        const getButtonStyle = () => {
          return {
            height: "20px",
            width: "20px",
            border: "none",
            borderRadius: "0",
            background: "transparent",
            buttonIconTint: "#7E57C2",
          };
        };
        return (
          <div style={{ marginRight: "20px" }}>
            <cometchat-button
              iconURL="icon"
              buttonStyle={JSON.stringify(getButtonStyle())}
              onClick={handleReload}
            >
              {" "}
            </cometchat-button>
          </div>
        );
      };
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} menus={getMenus()} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatAddMembers } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      const getMenus = () => {
        const handleReload = () => {
          window.location.reload();
        };
        const getButtonStyle = () => {
          return {
            height: "20px",
            width: "20px",
            border: "none",
            borderRadius: "0",
            background: "transparent",
            buttonIconTint: "#7E57C2",
          };
        };
        return (
          <div style={{ marginRight: "20px" }}>
            <cometchat-button
              iconURL="icon"
              buttonStyle={JSON.stringify(getButtonStyle())}
              onClick={handleReload}
            >
              {" "}
            </cometchat-button>
          </div>
        );
      };
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers group={chatGroup} menus={getMenus()} />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

***

#### Options

You can set the Custom options to the Add Members component.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/60KLvpM3Vx0byZeU/images/b65b8d18-add_members_options_web_screens-1271022dbc49fb6d4b57919c44860a62.png?fit=max&auto=format&n=60KLvpM3Vx0byZeU&q=85&s=1858d34321bd1851b73910f7453f8e98" width="3600" height="2400" data-path="images/b65b8d18-add_members_options_web_screens-1271022dbc49fb6d4b57919c44860a62.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    AddMembersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatAddMembers,
      CometChatOption,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = React.useState<
        CometChat.Group | undefined
      >();

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              options={(user: CometChat.User) => {
                const customOptions = [
                  new CometChatOption({
                    id: "1",
                    title: "Title",
                    iconURL: "icon",
                    backgroundColor: "transparent",
                    onClick: () => {
                      console.log("Custom option clicked:", user);
                    },
                    iconTint: "#890aff",
                    titleColor: "blue",
                  }),
                ];
                return customOptions;
              }}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    AddMembersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatAddMembers,
      CometChatOption,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const AddMembersDemo = () => {
      const [chatGroup, setChatGroup] = useState(null);

      React.useEffect(() => {
        CometChat.getGroup("uid").then((group) => {
          setChatGroup(group);
        });
      }, []);
      return (
        <>
          {chatGroup && (
            <CometChatAddMembers
              group={chatGroup}
              options={(user) => {
                const customOptions = [
                  new CometChatOption({
                    id: "1",
                    title: "Title",
                    iconURL: "icon",
                    backgroundColor: "transparent",
                    onClick: () => {
                      console.log("Custom option clicked:", user);
                    },
                    iconTint: "#890aff",
                    titleColor: "blue",
                  }),
                ];
                return customOptions;
              }}
            />
          )}
        </>
      );
    };

    export default AddMembersDemo;
    ```
  </Tab>
</Tabs>

***
